## pentobi 10.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

project(Pentobi)
set(PENTOBI_VERSION 10.0)

cmake_policy(SET CMP0043 NEW)

include(CheckIncludeFiles)
include(GNUInstallDirs)

option(PENTOBI_BUILD_TESTS "Build unit tests" OFF)
option(PENTOBI_BUILD_GTP "Build GTP interface" OFF)
option(PENTOBI_BUILD_GUI "Build Qt-based GUI" ON)
option(PENTOBI_BUILD_QML "Build QtQuick-based GUI" OFF)
option(PENTOBI_BUILD_KDE_THUMBNAILER "Build thumbnailer for KDE" OFF)
option(USE_QT5 "Use Qt 5 instead of Qt 4" OFF)

if (PENTOBI_BUILD_KDE_THUMBNAILER AND NOT PENTOBI_BUILD_GUI)
  message(FATAL_ERROR
    "PENTOBI_BUILD_KDE_THUMBNAILER requires PENTOBI_BUILD_GUI=1")
endif()
if (PENTOBI_BUILD_QML AND NOT USE_QT5)
  message(FATAL_ERROR "PENTOBI_BUILD_QML requires USE_QT5=1")
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DLIBBOARDGAME_DEBUG")

if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    OR (CMAKE_CXX_COMPILER_ID MATCHES "Intel"))
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffast-math")
endif()
if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE
    -D_SCL_SECURE_NO_WARNINGS)
endif()

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)

if(NOT DEFINED LIBPENTOBI_MCTS_FLOAT_TYPE)
  set(LIBPENTOBI_MCTS_FLOAT_TYPE float)
endif()

# Don't set the Pentobi data dirs on Windows. This is currently needed for
# building a version of Pentobi for the NSIS installer on Windows (see
# directory windows) such that Pentobi will look for data dirs relative to
# the installation directory. (It breaks installing Pentobi on Windows with
# "make install" but we don't support that on Windows anyway.)
if(UNIX)
  if(NOT DEFINED PENTOBI_BOOKS_DIR)
    set(PENTOBI_BOOKS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/pentobi/books")
  endif()
  if(NOT DEFINED PENTOBI_HELP_DIR)
    set(PENTOBI_HELP_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/help")
  endif()
  if(NOT DEFINED PENTOBI_TRANSLATIONS)
    set(PENTOBI_TRANSLATIONS
      "${CMAKE_INSTALL_FULL_DATADIR}/pentobi/translations")
  endif()
endif(UNIX)

configure_file(config.h.in config.h)
add_definitions(-DHAVE_CONFIG_H)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(${CMAKE_SOURCE_DIR}/src)

if(PENTOBI_BUILD_TESTS)
  enable_testing()
endif()

find_package(Threads)

if(PENTOBI_BUILD_GUI)
  if (USE_QT5)
    find_package(Qt5Concurrent REQUIRED)
    find_package(Qt5Widgets REQUIRED)
    find_package(Qt5LinguistTools REQUIRED)
    find_package(Qt5Svg REQUIRED)
  else()
    find_package(Qt4 COMPONENTS QtCore QtGui QtSvg REQUIRED)
  endif()
endif()
if(PENTOBI_BUILD_QML)
  find_package(Qt5Concurrent 5.3 REQUIRED)
  find_package(Qt5Qml 5.3 REQUIRED)
  find_package(Qt5Gui 5.3 REQUIRED)
  find_package(Qt5Svg 5.3 REQUIRED)
endif()
# Enable support for high dpi images if Qt version is at least 5.1
set(PENTOBI_HDPI 0)
if(PENTOBI_BUILD_GUI AND USE_QT5)
  string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*$" "\\1" QT_VERSION_MINOR
      "${Qt5Widgets_VERSION}")
  if(${QT_VERSION_MINOR} GREATER 0)
    set(PENTOBI_HDPI 1)
  endif()
endif()

if(UNIX)
  add_custom_target(dist
    COMMAND git archive --prefix=pentobi-${PENTOBI_VERSION}/ HEAD
    | xz -e > ${CMAKE_BINARY_DIR}/pentobi-${PENTOBI_VERSION}.tar.xz
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

add_subdirectory(doc)
add_subdirectory(src)
add_subdirectory(data)
if(WIN32 AND PENTOBI_BUILD_GUI)
  add_subdirectory(windows)
endif()

=== windows/CMakeLists.txt ===
if(USE_QT5)
  get_target_property(QMAKE Qt5::qmake LOCATION)
  execute_process(COMMAND ${QMAKE} -query QT_INSTALL_TRANSLATIONS
    OUTPUT_VARIABLE QT_TRANSLATIONS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

configure_file(install.nsis.in install.nsis @ONLY)

=== src/convert/CMakeLists.txt ===
if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

add_executable(convert Main.cpp)

# CMake 2.8.9 doesn't seem to support finding plugin paths yet but
# we need to add qsvg to the linked libraries if static linking is
# used as by our current build of the Windows installer with MinGW.
# This should be fixed once CMake properly supports plugins because it
# breaks the build with dynamic libraries on MinGW and doesn't solve
# the problem with static libraries on other platforms.
if (MINGW)
  add_definitions(-DQT_STATICPLUGIN)
  if(QT_DEBUG)
    target_link_libraries(convert "${QT_PLUGINS_DIR}/imageformats/libqsvgd.a")
  else()
    target_link_libraries(convert "${QT_PLUGINS_DIR}/imageformats/libqsvg.a")
  endif()
endif()

if (USE_QT5)
  target_link_libraries(convert Qt5::Widgets)
else()
  target_link_libraries(convert
    ${QT_QTSVG_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIB_DEPENDENCIES}
    ${QT_QTCORE_LIB_DEPENDENCIES}
    )
endif()

=== src/libboardgame_mcts/CMakeLists.txt ===
# This library contains only header files with templates. The empty target
# exists only to add the headers to IDE project files.
add_custom_target(boardgame_mcts SOURCES
  Atomic.h
  BiasTerm.h
  LastGoodReply.h
  Node.h
  PlayerMove.h
  SearchBase.h
  Tree.h
  TreeUtil.h
)

=== src/libpentobi_base/CMakeLists.txt ===
set(pentobi_base_STAT_SRCS
  BoardConst.h
  BoardConst.cpp
  Board.h
  Board.cpp
  BoardUpdater.h
  BoardUpdater.cpp
  BoardUtil.h
  BoardUtil.cpp
  Book.h
  Book.cpp
  Color.h
  Color.cpp
  ColorMap.h
  ColorMove.h
  Game.h
  Game.cpp
  Geometry.h
  Grid.h
  Marker.h
  Move.h
  MoveInfo.h
  MoveList.h
  MoveMarker.h
  MovePoints.h
  NodeUtil.h
  NodeUtil.cpp
  PentobiSgfUtil.h
  PentobiSgfUtil.cpp
  PentobiTree.h
  PentobiTree.cpp
  PentobiTreeWriter.h
  PentobiTreeWriter.cpp
  Piece.h
  PieceInfo.h
  PieceInfo.cpp
  PieceMap.h
  PieceTransformsClassic.h
  PieceTransformsClassic.cpp
  PieceTransformsClassic.h
  PieceTransforms.cpp
  PieceTransformsTrigon.h
  PieceTransformsTrigon.cpp
  PlayerBase.h
  PlayerBase.cpp
  Point.h
  PointList.h
  PointState.h
  PointState.cpp
  PrecompMoves.h
  ScoreUtil.h
  Setup.h
  StartingPoints.h
  StartingPoints.cpp
  SymmetricPoints.h
  SymmetricPoints.cpp  
  TreeUtil.h
  TreeUtil.cpp
  TrigonGeometry.h
  TrigonGeometry.cpp
  TrigonTransform.h
  TrigonTransform.cpp
  Variant.h
  Variant.cpp
)

if (PENTOBI_BUILD_GTP)
  set(pentobi_base_STAT_SRCS ${pentobi_base_STAT_SRCS}
    Engine.cpp
    Engine.h
  )
endif()

add_library(pentobi_base STATIC ${pentobi_base_STAT_SRCS})

=== src/libpentobi_gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

set(pentobi_gui_STAT_SRCS
  BoardPainter.h
  BoardPainter.cpp
  ComputerColorDialog.h
  ComputerColorDialog.cpp
  GameInfoDialog.h
  GameInfoDialog.cpp
  GuiBoard.h
  GuiBoard.cpp
  GuiBoardUtil.h
  GuiBoardUtil.cpp
  HelpWindow.h
  HelpWindow.cpp
  InitialRatingDialog.h
  InitialRatingDialog.cpp
  LeaveFullscreenButton.h
  LeaveFullscreenButton.cpp
  LineEdit.h
  LineEdit.cpp
  OrientationDisplay.h
  OrientationDisplay.cpp
  PieceSelector.h
  PieceSelector.cpp
  SameHeightLayout.h
  SameHeightLayout.cpp
  ScoreDisplay.h
  ScoreDisplay.cpp
  Util.h
  Util.cpp
)

set(pentobi_gui_ICNS
  go-home.png
  go-next.png
  go-previous.png
)

set(pentobi_gui_TS
  libpentobi_gui_de.ts
  )

# Create PNG icons from SVG icons using the helper program src/convert
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/icons)
file(COPY libpentobi_gui_resources.qrc DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
foreach(icon ${pentobi_gui_ICNS})
  string(REPLACE ".png" ".svg" svgicon ${icon})
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}"
    COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
      ${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
  )
endforeach()
if(USE_QT5)
  qt5_add_resources(pentobi_gui_RC_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/libpentobi_gui_resources.qrc
      OPTIONS -no-compress)
else()
  qt4_add_resources(pentobi_gui_RC_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/libpentobi_gui_resources.qrc
      OPTIONS -no-compress)
endif()
if(PENTOBI_HDPI)
  file(COPY libpentobi_gui_resources_2x.qrc DESTINATION
      ${CMAKE_CURRENT_BINARY_DIR})
  foreach(icon ${pentobi_gui_ICNS})
    string(REPLACE ".png" ".svg" svgicon ${icon})
    string(REPLACE ".png" "@2x.png" hdpiicon ${icon})
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${hdpiicon}"
      COMMAND convert --hdpi ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
        ${CMAKE_CURRENT_BINARY_DIR}/icons/${hdpiicon}
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
  )
  endforeach()
  qt5_add_resources(pentobi_gui_RC_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/libpentobi_gui_resources_2x.qrc
      OPTIONS -no-compress)
endif()

# We don't use qt4_add_translation because it doesn't use option
# -removeidentical (see QTBUG-44323)
if(USE_QT5)
  set(LRELEASE_EXECUTABLE ${Qt5_LRELEASE_EXECUTABLE})
else()
  set(LRELEASE_EXECUTABLE ${QT_LRELEASE_EXECUTABLE})
endif()
set(pentobi_gui_QM_SRCS)
foreach(ts ${pentobi_gui_TS})
  get_filename_component(qm ${ts} NAME_WE)
  set(qm "${CMAKE_CURRENT_BINARY_DIR}/${qm}.qm")
  add_custom_command(OUTPUT ${qm}
    COMMAND ${LRELEASE_EXECUTABLE} -removeidentical -nounfinished
      ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} -qm ${qm}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} VERBATIM
    )
  set(pentobi_gui_QM_SRCS ${pentobi_gui_QM_SRCS} ${qm})
endforeach()

add_library(pentobi_gui STATIC
  ${pentobi_gui_STAT_SRCS}
  ${pentobi_gui_RC_SRCS}
  ${pentobi_gui_QM_SRCS})

if (USE_QT5)
  target_link_libraries(pentobi_gui Qt5::Widgets)
endif()

# Install translation files. If you change the destination, you need to
# update the default for PENTOBI_TRANSLATIONS in the main CMakeLists.txt
install(FILES ${pentobi_gui_QM_SRCS}
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/translations)

=== src/libpentobi_kde_thumbnailer/CMakeLists.txt ===
# libpentobi_kde_thumbnailer contains the files needed by
# the pentobi_kde_thumbnailer plugin compiled with shared library options
# (usually -fPIC) because this is required for building shared libraries on
# some targets (e.g. x86_64).
#
# The alternative would be to add -fPIC to the global compiler flags even for
# executables but this slows down Pentobi's search by 10% on some targets.
#
# Adding the source files directly to pentobi_kde_thumbnailer/CMakeList.txt is
# not possible because the KDE CMake macros add -fno-exceptions to the
# compiler flags which causes errors in the Pentobi sources that use
# exceptions (which should be fine as long as no exceptions are thrown
# from the thumbnailer plugin functions).

if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")

add_library(pentobi_kde_thumbnailer STATIC
  ../libboardgame_util/Assert.cpp
  ../libboardgame_util/Log.cpp
  ../libboardgame_util/StringUtil.cpp
  ../libboardgame_base/SpShtStrRep.cpp
  ../libboardgame_sgf/MissingProperty.cpp
  ../libboardgame_sgf/Reader.cpp
  ../libboardgame_sgf/SgfNode.cpp
  ../libboardgame_sgf/SgfTree.cpp
  ../libboardgame_sgf/TreeReader.cpp
  ../libpentobi_base/NodeUtil.cpp
  ../libpentobi_base/StartingPoints.cpp
  ../libpentobi_base/TrigonGeometry.cpp
  ../libpentobi_base/Variant.cpp
  ../libpentobi_gui/BoardPainter.cpp
  ../libpentobi_gui/Util.cpp
  ../libpentobi_thumbnail/CreateThumbnail.cpp
)

if (USE_QT5)
  target_link_libraries(pentobi_kde_thumbnailer Qt5::Widgets)
endif()

=== src/libpentobi_thumbnail/CMakeLists.txt ===
if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

add_library(pentobi_thumbnail STATIC
  CreateThumbnail.h
  CreateThumbnail.cpp
)

if (USE_QT5)
  target_link_libraries(pentobi_thumbnail Qt5::Widgets)
endif()

=== src/pentobi/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

if (NOT USE_QT5)
  include(${QT_USE_FILE})
endif()

set(pentobi_SRCS
  AnalyzeGameWidget.h
  AnalyzeGameWidget.cpp
  AnalyzeGameWindow.h
  AnalyzeGameWindow.cpp
  AnalyzeSpeedDialog.h
  AnalyzeSpeedDialog.cpp
  Application.h
  Application.cpp
  Main.cpp
  MainWindow.h
  MainWindow.cpp
  RatedGamesList.h
  RatedGamesList.cpp
  RatingDialog.h
  RatingDialog.cpp
  RatingGraph.h
  RatingGraph.cpp
  RatingHistory.h
  RatingHistory.cpp
  ShowMessage.h
  ShowMessage.cpp
  Util.h
  Util.cpp
  pentobi.rc
)

set(pentobi_ICNS
  pentobi.png
  pentobi-16.png
  pentobi-32.png
  pentobi-backward.png
  pentobi-backward-16.png
  pentobi-beginning.png
  pentobi-beginning-16.png
  pentobi-computer-colors.png
  pentobi-computer-colors-16.png
  pentobi-end.png
  pentobi-end-16.png
  pentobi-flip-horizontal.png
  pentobi-flip-vertical.png
  pentobi-forward.png
  pentobi-forward-16.png
  pentobi-newgame.png
  pentobi-newgame-16.png
  pentobi-next-piece.png
  pentobi-next-variation.png
  pentobi-next-variation-16.png
  pentobi-piece-clear.png
  pentobi-play.png
  pentobi-play-16.png
  pentobi-previous-piece.png
  pentobi-previous-variation.png
  pentobi-previous-variation-16.png
  pentobi-rated-game.png
  pentobi-rated-game-16.png
  pentobi-rotate-left.png
  pentobi-rotate-right.png
  )

set(pentobi_TS
  pentobi.ts
  pentobi_de.ts
  )

# Create PNG icons from SVG icons using the helper program src/convert
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/icons)
file(COPY resources.qrc DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
foreach(icon ${pentobi_ICNS})
  string(REPLACE ".png" ".svg" svgicon ${icon})
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}"
    COMMAND convert  ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
      ${CMAKE_CURRENT_BINARY_DIR}/icons/${icon}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
  )
endforeach()
if(USE_QT5)
  qt5_add_resources(pentobi_RC_SRCS ${CMAKE_CURRENT_BINARY_DIR}/resources.qrc
      OPTIONS -no-compress)
else()
  qt4_add_resources(pentobi_RC_SRCS ${CMAKE_CURRENT_BINARY_DIR}/resources.qrc
      OPTIONS -no-compress)
endif()
if(PENTOBI_HDPI)
  file(COPY resources_2x.qrc DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  foreach(icon ${pentobi_ICNS})
    string(REPLACE ".png" ".svg" svgicon ${icon})
    string(REPLACE ".png" "@2x.png" hdpiicon ${icon})
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/icons/${hdpiicon}"
      COMMAND convert --hdpi ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
        ${CMAKE_CURRENT_BINARY_DIR}/icons/${hdpiicon}
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/${svgicon}
  )
  endforeach()
  qt5_add_resources(pentobi_RC_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/resources_2x.qrc OPTIONS -no-compress)
endif()

# We don't use qt4_add_translation because it doesn't use option
# -removeidentical (see QTBUG-44323)
if(USE_QT5)
  set(LRELEASE_EXECUTABLE ${Qt5_LRELEASE_EXECUTABLE})
else()
  set(LRELEASE_EXECUTABLE ${QT_LRELEASE_EXECUTABLE})
endif()
set(pentobi_QM_SRCS)
foreach(ts ${pentobi_TS})
  get_filename_component(qm ${ts} NAME_WE)
  set(qm "${CMAKE_CURRENT_BINARY_DIR}/${qm}.qm")
  add_custom_command(OUTPUT ${qm}
    COMMAND ${LRELEASE_EXECUTABLE} -removeidentical -nounfinished
      ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} -qm ${qm}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/translations/${ts} VERBATIM
    )
  set(pentobi_QM_SRCS ${pentobi_QM_SRCS} ${qm})
endforeach()

add_executable(pentobi WIN32
  ${pentobi_SRCS}
  ${pentobi_QM_SRCS}
  ${pentobi_RC_SRCS}
  )


if(MINGW AND (CMAKE_SIZEOF_VOID_P EQUAL "4"))
  set_target_properties(pentobi PROPERTIES LINK_FLAGS -Wl,--large-address-aware)
endif()

target_link_libraries(pentobi
  pentobi_gui
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_util
  boardgame_sys
  )

if (USE_QT5)
  target_link_libraries(pentobi Qt5::Widgets Qt5::Concurrent)
else()
  target_link_libraries(pentobi
    ${QT_QTGUI_LIBRARY}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIB_DEPENDENCIES}
    ${QT_QTCORE_LIB_DEPENDENCIES}
    )
endif()

if (DEFINED CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(pentobi ${CMAKE_THREAD_LIBS_INIT})
endif()

install(TARGETS pentobi DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install translation files. If you change the destination, you need to
# update the default for PENTOBI_TRANSLATIONS in the main CMakeLists.txt
install(FILES ${pentobi_QM_SRCS}
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/translations)

install(DIRECTORY help DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}
  FILES_MATCHING PATTERN "*.css" PATTERN "*.html" PATTERN "*.png" PATTERN "*.jpg")

if(MSVC)
  configure_file(pentobi.conf.in Debug/pentobi.conf @ONLY)
  configure_file(pentobi.conf.in Release/pentobi.conf @ONLY)
else()
  configure_file(pentobi.conf.in pentobi.conf @ONLY)
endif()

=== src/pentobi_gtp/CMakeLists.txt ===
add_executable(pentobi-gtp
  Engine.h
  Engine.cpp
  Main.cpp
)

target_link_libraries(pentobi-gtp
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_util
  boardgame_sys
  boardgame_gtp
  )

if (DEFINED CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(pentobi-gtp ${CMAKE_THREAD_LIBS_INIT})
endif()

if(MINGW AND (CMAKE_SIZEOF_VOID_P EQUAL "4"))
  set_target_properties(pentobi-gtp PROPERTIES LINK_FLAGS -Wl,--large-address-aware)
endif()

=== src/pentobi_kde_thumbnailer/CMakeLists.txt ===
if (USE_QT5)


find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECompilerSettings)
include(KDECMakeSettings)

find_package(KF5 REQUIRED COMPONENTS KIO)

include_directories(${CMAKE_SOURCE_DIR}/src)

add_library(pentobi-thumbnail MODULE
  PentobiThumbCreator.h
  PentobiThumbCreator.cpp
)

target_link_libraries(pentobi-thumbnail
  pentobi_kde_thumbnailer
  KF5::KIOWidgets
)


else(USE_QT5)


find_package(KDE4 REQUIRED)

include(KDE4Defaults)

include_directories(
  ${CMAKE_SOURCE_DIR}/src
  ${KDE4_INCLUDES}
  ${QT_INCLUDES}
)

kde4_add_plugin(pentobi-thumbnail
  PentobiThumbCreator.h
  PentobiThumbCreator.cpp
)

target_link_libraries(pentobi-thumbnail
  pentobi_kde_thumbnailer
  ${KDE4_KIO_LIBS}
)

endif(USE_QT5)


install(TARGETS pentobi-thumbnail DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES pentobi-thumbnail.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== src/pentobi_qml/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

include_directories(${CMAKE_SOURCE_DIR}/src)

set(pentobi_qml_SRCS
  BoardModel.h
  BoardModel.cpp
  Main.cpp
  PieceModel.h
  PieceModel.cpp
  PlayerModel.h
  PlayerModel.cpp
)

qt5_add_resources(pentobi_qml_RC_SRCS
  resources.qrc
  qml/themes/light/theme_light.qrc
  ../books/pentobi_books.qrc
  ../pentobi/icons_base.qrc
)

add_executable(pentobi_qml WIN32
  ${pentobi_qml_SRCS}
  ${pentobi_qml_RC_SRCS}
)

target_link_libraries(pentobi_qml
  pentobi_mcts
  pentobi_base
  boardgame_base
  boardgame_sgf
  boardgame_util
  boardgame_sys
)

qt5_use_modules(pentobi_qml Concurrent Gui Qml Svg)

if (DEFINED CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(pentobi_qml ${CMAKE_THREAD_LIBS_INIT})
endif()

=== debian/changelog ===
pentobi (10.0-1) unstable; urgency=medium

  * New upstream release.
  * Build with Qt5.
    - d/rules: Add Qt5 cmake flags.
    - d/control: Adjust Build-Deps.
    - d/pentobi-kde-thumbnailer.install: Adjust for new install locations.
  * Drop now unneeded override_dh_install.
  * d/pentobi.install, d/pentobi.doc-base.*: Adjust for new help path.
  * d/pentobi.doc-base.manual-en-{ca,gb}: en_CA, en_GB dropped upstream.
  * d/copyright: Update copyright years.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 05 Jul 2015 19:37:05 +0300

pentobi (9.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Reduce size of d/upstream/signing-key.asc by using a minimally exported key.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 30 Apr 2015 18:39:00 +0300

=== debian/control ===
Source: pentobi
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dean Evans <dean@codemonkies.net>,
           Juhani Numminen <juhaninumminen0@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               extra-cmake-modules,
               kio-dev,
               libqt5svg5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 3.9.6
Homepage: http://pentobi.sourceforge.net
Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/pentobi.git

Package: pentobi
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: pentobi-kde-thumbnailer
Description: clone of the strategy board game Blokus
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 The game ends when no one can place any more pieces and the winner is
 determined by calculating the score based on the points of any remaining
 playing pieces. Bonus points are added for playing every piece and additional
 bonus points are added if the monomino, the 1x1 square piece, is played last.

Package: pentobi-kde-thumbnailer
Architecture: any
Section: kde
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: dolphin, konqueror
Description: clone of the strategy board game Blokus - KDE thumbnailer
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 This package contains a KDE plugin to display thumbnails of Pentobi game files.

=== debian/rules ===
#!/usr/bin/make -f

# Optimize with O3 to make the computationally expensive higher levels faster.
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  export DEB_CXXFLAGS_MAINT_APPEND = -O3
endif

# Avoid dependencies on unused libraries.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games \
		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
		-DUSE_QT5=ON \
		-DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
		-DPENTOBI_BUILD_TESTS=ON

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	# dh_makeshlibs not needed, the KDE thumbnailer .so file is a plugin

## pentobi 11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.0.2)
 
 project(Pentobi)
-set(PENTOBI_VERSION 10.0)
+set(PENTOBI_VERSION 11.0)
 
 cmake_policy(SET CMP0043 NEW)
 
@@ -13,14 +13,10 @@
 option(PENTOBI_BUILD_GUI "Build Qt-based GUI" ON)
 option(PENTOBI_BUILD_QML "Build QtQuick-based GUI" OFF)
 option(PENTOBI_BUILD_KDE_THUMBNAILER "Build thumbnailer for KDE" OFF)
-option(USE_QT5 "Use Qt 5 instead of Qt 4" OFF)
 
 if (PENTOBI_BUILD_KDE_THUMBNAILER AND NOT PENTOBI_BUILD_GUI)
   message(FATAL_ERROR
     "PENTOBI_BUILD_KDE_THUMBNAILER requires PENTOBI_BUILD_GUI=1")
-endif()
-if (PENTOBI_BUILD_QML AND NOT USE_QT5)
-  message(FATAL_ERROR "PENTOBI_BUILD_QML requires USE_QT5=1")
 endif()
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
@@ -80,29 +76,16 @@
 find_package(Threads)
 
 if(PENTOBI_BUILD_GUI)
-  if (USE_QT5)
-    find_package(Qt5Concurrent REQUIRED)
-    find_package(Qt5Widgets REQUIRED)
-    find_package(Qt5LinguistTools REQUIRED)
-    find_package(Qt5Svg REQUIRED)
-  else()
-    find_package(Qt4 COMPONENTS QtCore QtGui QtSvg REQUIRED)
-  endif()
+  find_package(Qt5Concurrent 5.1 REQUIRED)
+  find_package(Qt5Widgets 5.1 REQUIRED)
+  find_package(Qt5LinguistTools 5.1 REQUIRED)
+  find_package(Qt5Svg 5.1 REQUIRED)
 endif()
 if(PENTOBI_BUILD_QML)
   find_package(Qt5Concurrent 5.3 REQUIRED)
   find_package(Qt5Qml 5.3 REQUIRED)
   find_package(Qt5Gui 5.3 REQUIRED)
   find_package(Qt5Svg 5.3 REQUIRED)
-endif()
-# Enable support for high dpi images if Qt version is at least 5.1
-set(PENTOBI_HDPI 0)
-if(PENTOBI_BUILD_GUI AND USE_QT5)
-  string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*$" "\\1" QT_VERSION_MINOR
-      "${Qt5Widgets_VERSION}")
-  if(${QT_VERSION_MINOR} GREATER 0)
-    set(PENTOBI_HDPI 1)
-  endif()
 endif()
 
 if(UNIX)

=== data/CMakeLists.txt ===
if(PENTOBI_BUILD_GUI AND NOT WIN32)

# Create bitmap icons from SVG icons using the helper program src/convert
# There is no 64x64 app icon yet, so we simply scale up pentobi-32 with --hdpi
add_custom_target(
  pentobi-64.png ALL
  COMMAND convert --hdpi ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg pentobi-64.png
  DEPENDS ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg
  )
add_custom_target(
  application-x-blokus-sgf.png ALL
  COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf.svg application-x-blokus-sgf.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf.svg
  )
add_custom_target(
  application-x-blokus-sgf-16.png ALL
  COMMAND convert ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf-16.svg application-x-blokus-sgf-16.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf-16.svg
  )

configure_file(pentobi.desktop.in pentobi.desktop @ONLY)
configure_file(pentobi.thumbnailer.in pentobi.thumbnailer @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-16.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps
  RENAME pentobi.png)
install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-32.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps
  RENAME pentobi.png)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi-64.png
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
    RENAME pentobi.png)
install(FILES ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/mimetypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf-16.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/mimetypes
  RENAME application-x-blokus-sgf.png)
install(FILES application-x-blokus-sgf.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/mimetypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.thumbnailer
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/thumbnailers)
install(FILES pentobi-mime.xml
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mime/packages)
install(FILES pentobi.appdata.xml
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/appdata)

endif(PENTOBI_BUILD_GUI AND NOT WIN32)

=== windows/CMakeLists.txt ===
# Build the NSIS installer
# We assume dynamic linking and add a custom target that runs makensis and
# uses windeployqt to include the Qt libraries.

get_target_property(QMAKE Qt5::qmake LOCATION)
find_program(WINDEPLOYQT windeployqt.exe HINTS "${QMAKE}")

set(X86 "(x86)")
find_program(MAKENSIS makensis
  PATHS "$ENV{ProgramFiles}\\NSIS" "$ENV{ProgramFiles${X86}}\\NSIS")

add_custom_target(nsis
  COMMAND ${CMAKE_COMMAND} -E remove_directory deploy
  COMMAND ${CMAKE_COMMAND} -E make_directory deploy
  COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:pentobi>" deploy
  COMMAND ${WINDEPLOYQT} --dir deploy --release --no-svg "deploy/pentobi.exe"
  COMMAND ${MAKENSIS} install.nsis
)

configure_file(install.nsis.in install.nsis @ONLY)

=== doc/man/CMakeLists.txt ===
configure_file(pentobi.6.in pentobi.6 @ONLY)
configure_file(pentobi-thumbnailer.6.in pentobi-thumbnailer.6 @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/pentobi.6
  ${CMAKE_CURRENT_BINARY_DIR}/pentobi-thumbnailer.6
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)

=== src/books/CMakeLists.txt ===
# Install the opening book files. If you change the destination, you need to
# update the default for PENTOBI_BOOKS_DIR in the main CMakeLists.txt
install(FILES
  book_classic.blksgf
  book_classic_2.blksgf
  book_classic_3.blksgf
  book_duo.blksgf
  book_junior.blksgf
  book_nexos.blksgf
  book_nexos_2.blksgf
  book_trigon.blksgf
  book_trigon_2.blksgf
  book_trigon_3.blksgf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/pentobi/books)

=== src/convert/CMakeLists.txt ===
add_executable(convert Main.cpp)

target_link_libraries(convert Qt5::Widgets)

=== src/libboardgame_base/CMakeLists.txt ===
add_library(boardgame_base STATIC
  CoordPoint.h
  CoordPoint.cpp
  Engine.h
  Engine.cpp
  Geometry.h
  GeometryUtil.h
  Grid.h
  Marker.h
  Point.h
  PointTransform.h
  Rating.h
  Rating.cpp
  RectGeometry.h
  RectTransform.h
  RectTransform.cpp
  SpShtStrRep.h
  SpShtStrRep.cpp
  Transform.h
  Transform.cpp
)

=== src/libboardgame_gtp/CMakeLists.txt ===
add_library(boardgame_gtp STATIC
  Arguments.h
  Arguments.cpp
  CmdLine.h
  CmdLine.cpp
  CmdLineRange.h
  Engine.h
  Engine.cpp
  Failure.h
  Response.h
  Response.cpp
)

=== src/libboardgame_sgf/CMakeLists.txt ===
add_library(boardgame_sgf STATIC
  InvalidPropertyValue.h
  InvalidTree.h
  MissingProperty.h
  MissingProperty.cpp
  Reader.h
  Reader.cpp
  SgfNode.h
  SgfNode.cpp
  SgfTree.h
  SgfTree.cpp
  SgfUtil.h
  SgfUtil.cpp
  TreeReader.h
  TreeReader.cpp
  TreeWriter.h
  TreeWriter.cpp
  Writer.h
  Writer.cpp
)

=== src/libboardgame_test_main/CMakeLists.txt ===
add_library(boardgame_test_main STATIC Main.cpp)

=== src/libboardgame_util/CMakeLists.txt ===
add_library(boardgame_util STATIC
  Abort.h
  Abort.cpp
  ArrayList.h
  Assert.h
  Assert.cpp
  Barrier.h
  Barrier.cpp
  CpuTimeSource.h
  CpuTimeSource.cpp
  FmtSaver.h
  IntervalChecker.h
  IntervalChecker.cpp
  Log.h
  Log.cpp
  MathUtil.h
  Options.h
  Options.cpp
  RandomGenerator.h
  RandomGenerator.cpp
  Statistics.h
  StringUtil.h
  StringUtil.cpp
  TimeIntervalChecker.h
  TimeIntervalChecker.cpp
  Timer.h
  Timer.cpp
  TimeSource.h
  TimeSource.cpp
  Unused.h
  WallTimeSource.h
  WallTimeSource.cpp
)

=== src/libpentobi_base/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,8 @@
   MoveList.h
   MoveMarker.h
   MovePoints.h
+  NexosGeometry.h
+  NexosGeometry.cpp
   NodeUtil.h
   NodeUtil.cpp
   PentobiSgfUtil.h
@@ -53,7 +55,7 @@
   StartingPoints.h
   StartingPoints.cpp
   SymmetricPoints.h
-  SymmetricPoints.cpp  
+  SymmetricPoints.cpp
   TreeUtil.h
   TreeUtil.cpp
   TrigonGeometry.h

=== debian/changelog ===
pentobi (11.0-1) unstable; urgency=medium

  * New upstream release.
  * d/rules: "USE_QT5" not needed, qt4 support was dropped upstream.
  * d/pentobi.install: Add usr/share/appdata, remove usr/share/pixmaps.
  * d/control: Update Vcs-Browser field to use https.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sat, 02 Jan 2016 19:40:55 +0200

pentobi (10.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop debian/pentobi.menu as per tech-ctte decision in #741573.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 24 Dec 2015 18:14:00 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Standards-Version: 3.9.6
 Homepage: http://pentobi.sourceforge.net
 Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/pentobi.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/pentobi.git
 
 Package: pentobi
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,6 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_BINDIR=/usr/games \
 		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
-		-DUSE_QT5=ON \
 		-DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
 		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
 		-DPENTOBI_BUILD_TESTS=ON

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://sf.net/pentobi/pentobi-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pentobi 12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 cmake_minimum_required(VERSION 3.0.2)
 
 project(Pentobi)
-set(PENTOBI_VERSION 11.0)
+set(PENTOBI_VERSION 12.0)
+set(PENTOBI_RELEASE_DATE 2016-04-10)
 
 cmake_policy(SET CMP0043 NEW)
 
@@ -76,12 +77,13 @@
 find_package(Threads)
 
 if(PENTOBI_BUILD_GUI)
-  find_package(Qt5Concurrent 5.1 REQUIRED)
-  find_package(Qt5Widgets 5.1 REQUIRED)
-  find_package(Qt5LinguistTools 5.1 REQUIRED)
-  find_package(Qt5Svg 5.1 REQUIRED)
+  find_package(Qt5Concurrent 5.2 REQUIRED)
+  find_package(Qt5Widgets 5.2 REQUIRED)
+  find_package(Qt5LinguistTools 5.2 REQUIRED)
+  find_package(Qt5Svg 5.2 REQUIRED)
 endif()
 if(PENTOBI_BUILD_QML)
+  # Qt 5.3 is good enough for building but the QML files require Qt 5.6 to run
   find_package(Qt5Concurrent 5.3 REQUIRED)
   find_package(Qt5Qml 5.3 REQUIRED)
   find_package(Qt5Gui 5.3 REQUIRED)

=== debian/changelog ===
pentobi (12.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control:
    - Bump Standards-Version to 3.9.8, no changes needed.
    - Unify Vcs-Git and Vcs-Browser.
    - Konqueror is not KDE Frameworks 5 application and thus cannot use
      pentobi-kde-thumbnailer; removed Enhances.
  * d/copyright: Update copyright years.
  * d/patches/desktop-semicolon.patch: Add a missing ; in desktop file.
  * d/rules: Enable all hardening flags.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Tue, 17 May 2016 21:41:19 +0300

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,10 @@
                libqt5svg5-dev,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://pentobi.sourceforge.net
-Vcs-Git: git://anonscm.debian.org/pkg-games/pentobi.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/pentobi.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-games/pentobi.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-games/pentobi.git
 
 Package: pentobi
 Architecture: any
@@ -35,7 +35,7 @@
 Architecture: any
 Section: kde
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Enhances: dolphin, konqueror
+Enhances: dolphin
 Description: clone of the strategy board game Blokus - KDE thumbnailer
  Pentobi is a strategy board game played on a square grid board using playing
  pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # Optimize with O3 to make the computationally expensive higher levels faster.
 ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
   export DEB_CXXFLAGS_MAINT_APPEND = -O3
 endif
-
-# Avoid dependencies on unused libraries.
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
 	dh $@ --parallel

## pentobi 12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.0.2)
 
 project(Pentobi)
-set(PENTOBI_VERSION 12.0)
-set(PENTOBI_RELEASE_DATE 2016-04-10)
+set(PENTOBI_VERSION 12.2)
+set(PENTOBI_RELEASE_DATE 2017-01-05)
 
 cmake_policy(SET CMP0043 NEW)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,9 @@
 if(PENTOBI_BUILD_GUI AND NOT WIN32)
 
-# Create bitmap icons from SVG icons using the helper program src/convert
-# There is no 64x64 app icon yet, so we simply scale up pentobi-32 with --hdpi
 add_custom_target(
   pentobi-64.png ALL
-  COMMAND convert --hdpi ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg pentobi-64.png
-  DEPENDS ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-32.svg
+  COMMAND convert ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-64.svg pentobi-64.png
+  DEPENDS ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi-64.svg
   )
 add_custom_target(
   application-x-blokus-sgf.png ALL
@@ -20,6 +18,7 @@
 
 configure_file(pentobi.desktop.in pentobi.desktop @ONLY)
 configure_file(pentobi.thumbnailer.in pentobi.thumbnailer @ONLY)
+configure_file(pentobi.appdata.xml.in pentobi.appdata.xml @ONLY)
 install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi.png
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
 install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-16.png
@@ -28,9 +27,9 @@
 install(FILES ${CMAKE_BINARY_DIR}/src/pentobi/icons/pentobi-32.png
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps
   RENAME pentobi.png)
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi-64.png
-    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
-    RENAME pentobi.png)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi-64.png
+  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
+  RENAME pentobi.png)
 install(FILES ${CMAKE_SOURCE_DIR}/src/pentobi/icons/pentobi.svg
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf.png
@@ -46,7 +45,7 @@
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/thumbnailers)
 install(FILES pentobi-mime.xml
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mime/packages)
-install(FILES pentobi.appdata.xml
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.appdata.xml
   DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/appdata)
 
 endif(PENTOBI_BUILD_GUI AND NOT WIN32)

=== src/CMakeLists.txt ===
add_subdirectory(books)
add_subdirectory(libboardgame_sys)
add_subdirectory(libboardgame_util)
add_subdirectory(libboardgame_sgf)
add_subdirectory(libboardgame_base)
add_subdirectory(libboardgame_mcts)
add_subdirectory(libpentobi_base)
add_subdirectory(libpentobi_mcts)

if (PENTOBI_BUILD_GTP)
  add_subdirectory(libboardgame_gtp)
  add_subdirectory(pentobi_gtp)
  if(HAVE_UNISTD_H AND NOT(WIN32))
    add_subdirectory(twogtp)
  else()
    message(STATUS "Not building twogtp, needs POSIX")
  endif()
endif()

if (PENTOBI_BUILD_TESTS)
  add_subdirectory(libboardgame_test)
  add_subdirectory(libboardgame_test_main)
  add_subdirectory(unittest)
endif()

if (PENTOBI_BUILD_GUI)
  add_subdirectory(convert)
  add_subdirectory(libpentobi_gui)
  add_subdirectory(libpentobi_thumbnail)
  add_subdirectory(pentobi_thumbnailer)
  add_subdirectory(pentobi)
  if(PENTOBI_BUILD_KDE_THUMBNAILER)
    add_subdirectory(libpentobi_kde_thumbnailer)
    add_subdirectory(pentobi_kde_thumbnailer)
  endif()
endif()

if (PENTOBI_BUILD_QML)
  add_subdirectory(pentobi_qml)
endif()

=== src/books/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 # Install the opening book files. If you change the destination, you need to
 # update the default for PENTOBI_BOOKS_DIR in the main CMakeLists.txt
 install(FILES
+  book_callisto.blksgf
+  book_callisto_2.blksgf
+  book_callisto_3.blksgf
   book_classic.blksgf
   book_classic_2.blksgf
   book_classic_3.blksgf

=== src/libboardgame_base/CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,8 @@
   RectGeometry.h
   RectTransform.h
   RectTransform.cpp
-  SpShtStrRep.h
-  SpShtStrRep.cpp
+  StringRep.h
+  StringRep.cpp
   Transform.h
   Transform.cpp
 )

=== src/libboardgame_sys/CMakeLists.txt ===
add_library(boardgame_sys STATIC
  Compiler.h
  CpuTime.h
  CpuTime.cpp
  Memory.h
  Memory.cpp
)

=== src/libpentobi_base/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,8 @@
   BoardUtil.cpp
   Book.h
   Book.cpp
+  CallistoGeometry.h
+  CallistoGeometry.cpp
   Color.h
   Color.cpp
   ColorMap.h

=== src/libpentobi_kde_thumbnailer/CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,9 @@
 #
 # Adding the source files directly to pentobi_kde_thumbnailer/CMakeList.txt is
 # not possible because the KDE CMake macros add -fno-exceptions to the
-# compiler flags which causes errors in the Pentobi sources that use
+# compiler flags, which causes errors in the Pentobi sources that use
 # exceptions (which should be fine as long as no exceptions are thrown
 # from the thumbnailer plugin functions).
-
-if (NOT USE_QT5)
-  include(${QT_USE_FILE})
-endif()
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
 
@@ -22,12 +18,14 @@
   ../libboardgame_util/Assert.cpp
   ../libboardgame_util/Log.cpp
   ../libboardgame_util/StringUtil.cpp
-  ../libboardgame_base/SpShtStrRep.cpp
+  ../libboardgame_base/StringRep.cpp
   ../libboardgame_sgf/MissingProperty.cpp
   ../libboardgame_sgf/Reader.cpp
   ../libboardgame_sgf/SgfNode.cpp
   ../libboardgame_sgf/SgfTree.cpp
   ../libboardgame_sgf/TreeReader.cpp
+  ../libpentobi_base/CallistoGeometry.cpp
+  ../libpentobi_base/NexosGeometry.cpp
   ../libpentobi_base/NodeUtil.cpp
   ../libpentobi_base/StartingPoints.cpp
   ../libpentobi_base/TrigonGeometry.cpp
@@ -37,6 +35,4 @@
   ../libpentobi_thumbnail/CreateThumbnail.cpp
 )
 
-if (USE_QT5)
-  target_link_libraries(pentobi_kde_thumbnailer Qt5::Widgets)
-endif()
+target_link_libraries(pentobi_kde_thumbnailer Qt5::Widgets)

=== src/libpentobi_mcts/CMakeLists.txt ===
add_library(pentobi_mcts STATIC
  AnalyzeGame.h
  AnalyzeGame.cpp
  Float.h
  History.h
  History.cpp
  Player.h
  Player.cpp
  PlayoutFeatures.h
  PlayoutFeatures.cpp
  PriorKnowledge.h
  PriorKnowledge.cpp
  SearchParamConst.h
  SharedConst.h
  SharedConst.cpp
  Search.h
  Search.cpp
  State.h
  State.cpp
  StateUtil.h
  StateUtil.cpp
  Util.h
  Util.cpp
)

=== src/twogtp/CMakeLists.txt ===
add_executable(twogtp
  Analyze.h
  Analyze.cpp
  FdStream.h
  FdStream.cpp
  GtpConnection.h
  GtpConnection.cpp
  Main.cpp
  Output.h
  Output.cpp
  OutputTree.h
  OutputTree.cpp
  TwoGtp.h
  TwoGtp.cpp
)

target_link_libraries(twogtp
  pentobi_base
  boardgame_sgf
  boardgame_base
  boardgame_util
  boardgame_sys
)

if(CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(twogtp ${CMAKE_THREAD_LIBS_INIT})
endif()

=== debian/changelog ===
pentobi (12.2-1) unstable; urgency=medium

  * New upstream release.
  * d/control: Build-Dep kio-dev was renamed to libkf5kio-dev, but keep
    the old name as an alternative (for Ubuntu).
  * d/copyright:
    - Update copyright years.
    - Use https in the copyright-format URL.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 05 Jan 2017 22:14:45 +0200

pentobi (12.1-1) unstable; urgency=medium

  * New upstream release.
    - Contains d/patches/desktop-semicolon.patch. Remove d/patches.
  * Use dh compat 10. Option --parallel is now default, dropped.
  * Mark pentobi-kde-thumbnailer Multi-Arch same, as hinted by MA-hinter.
  * Update watch file to version 4.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 01 Dec 2016 16:14:42 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Dean Evans <dean@codemonkies.net>,
            Juhani Numminen <juhaninumminen0@gmail.com>
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
                extra-cmake-modules,
-               kio-dev,
+               libkf5kio-dev | kio-dev,
                libqt5svg5-dev,
                qttools5-dev,
                qttools5-dev-tools
@@ -33,6 +33,7 @@
 
 Package: pentobi-kde-thumbnailer
 Architecture: any
+Multi-Arch: same
 Section: kde
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Enhances: dolphin

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
